:root {
    border-top: 0;
    font-size: 120%;
    --font-sans: inria-sans;
    --font-mono: fira-mono;
    --font-ui: clear-sans, system-ui, -apple-system,
               BlinkMacSystemFont, "Segoe UI", Helvetica, Cantarell,
               Roboto, sans-serif;
    --font-index: concourse_index;

    --font-default: 1.0rem;
    --font-xs: .72rem;
    --font-s: .86rem;
    --font-l: 1.25rem;

    --font-line-height: 1.4;
    --font-line-height-s: 1.0;
    --font-line-height-l: 1.6;

    --spacing-xs: 2vh;
    --spacing-s: 0.4rem;
    --spacing-m: 1rem;
    --spacing-l: 2rem;
    --spacing-xl: 4rem;

    --color-brand: #6800b3;
    --color-focus: rgb(21, 110, 0);
    --color-focus-shade: rgb(41, 90, 33);
    --color-key-focus: rgb(210, 170, 55);
    --color-surface-bg: #f8f8f8;
    --color-surface-border: #8f7ab3;
    --color-text: rgb(27, 21, 5);
    --color-secondary-text: #404040;

    --focus-outline-color:  CurrentColor;
    --focus-outline-offset: 3px;
    --focus-outline-style:  solid;
    --focus-outline-width:  3px;

    --max-width: 800px;
}

@supports (font: -apple-system-body) and (not (-webkit-touch-callout: default)) {
  :root {
    font-size: 120%;
  }
}

/* Fonts */
@font-face {
  font-family:  concourse_index;
  font-style:   normal;
  font-weight:  normal;
  font-stretch: normal;
  font-display: auto;
  src: url('../fonts/concourse_index_regular.woff2') format('woff2');
}
@font-face{
  font-family:  clear-sans;
  font-weight: 400;
  font-display: swap;
  src: url(../fonts/ClearSans-Regular-webfont.woff) format('woff');
}
@font-face{
  font-family:  clear-sans;
  font-weight:  500;
  font-display: swap;
  src: url(../fonts/ClearSans-Medium-webfont.woff) format('woff');
}
@font-face{
  font-family:  clear-sans;
  font-weight:  700;
  font-display: swap;
  src: url(../fonts/ClearSans-Bold-webfont.woff) format('woff');
}
@font-face {
  font-family: inria-sans;
  font-weight: 400;
  font-display: swap;
  src: url(../fonts/InriaSans-Regular.woff2) format("woff2"),
       url(../fonts/InriaSans-Regular.woff) format("woff");
}
@font-face {
  font-family: inria-sans;
  font-style: italic;
  font-weight: 400;
  font-display: swap;
  src: url(../fonts/InriaSans-Italic.woff2) format("woff2"),
       url(../fonts/InriaSans-Italic.woff) format("woff");
}
@font-face {
  font-family: inria-sans;
  font-weight: 700;
  font-display: swap;
  src: url(../fonts/InriaSans-Bold.woff2) format("woff2"),
       url(../fonts/InriaSans-Bold.woff) format("woff");
}
@font-face{
  font-family:  fira-mono;
  font-display: swap;
  size-adjust: 105%;
  src: url(../fonts/FiraMono-Regular.woff2) format('woff2'),
	     url(../fonts/FiraMono-Regular.woff) format('woff');
}
@font-face{
  font-family:  fira-mono;
  font-weight: 500;
  font-display: swap;
  size-adjust: 105%;
  src: url(../fonts/FiraMono-Medium.woff2) format('woff2'),
	     url(../fonts/FiraMono-Medium.woff) format('woff');
}

/* General styles */

*:focus-visible {
  outline-color: var(--focus-outline-color);
  outline-offset: var(--focus-outline-offset);
  outline-style: var(--focus-outline-style);
  outline-width: var(--focus-outline-width);
}

html {
  line-height: var(--font-line-height);
}

body {
  margin-left: auto;
  margin-right: auto;
  max-width: revert;
  font-family: var(--font-sans);
  padding: 0;
}

h1 {
  /* neat.css define line-height: 1em; */
  line-height: var(--font-line-height-s);
}

a {
  border-radius: .1rem;
  color: LinkText;
  text-decoration-thickness: .1em;
  text-underline-offset: .18em;
  transition: all ease-out .15s;
}

a:hover {
  text-decoration: underline;
  text-decoration-skip-ink: none;
  text-decoration-thickness: .3em;
  text-underline-offset: .25em;
}

.internal {
  text-decoration: none;
}

.muted {
  color: var(--color-secondary-text);
  font-family: var(--font-ui);
}

.am-link--inverse {
  color: #fff;
}

header {
  background-color: var(--color-brand);
}

article > header {
  all: revert;
}

article > h2 {
  font-weight: 400;
  line-height: var(--font-line-height);
}

blockquote {
  border-left: 10px solid;
  border-left-color: ButtonBorder;
  margin-top: var(--spacing-m);
  margin-bottom: var(--spacing-m);
  margin-left: 0;
  margin-right: 0;
  padding-left: 15px;
  clear: both;
}

.container > .rubric {
  background-color: var(--color-surface-bg);
  border-top-right-radius: .5rem;
  font-family: var(--font-mono);
  font-size: var(--font-xs);
  margin: 0;
  padding: var(--spacing-s);
}

pre, .highlight > * {
  background-color: revert;
  border-top: 1px solid ButtonBorder;
  border-bottom: 1px solid ButtonBorder;
  font-family: var(--font-mono);
  font-size: var(--font-xs);
  line-height: var(--font-line-height-l);
  margin: 0;
  padding: var(--spacing-s);
}

code, tt {
  font-family: var(--font-mono);
  font-size: 85%;
  padding: .1rem;
}

ul.simple {
  list-style: none;
  padding-left: var(--spacing-m);
}

ul.intro {
  list-style-type: disc;
}

ul.simple > li {
  margin-block-start: var(--spacing-s);
}

hr {
  color: #cecece;
}

.am-name {
  color: var(--light);
  font-size: var(--font-l);
  text-decoration: none;
}

.am-name:hover {
    text-decoration: none;
}

/* cv */
.bordered {
  border: none;
  border-top: 1px solid #7e7d88;
}

.font-ui {
  font-family: var(--font-ui);
}

.section-header {
  font-family: var(--font-ui);
  font-size: var(--font-s);
  font-weight: 700;
  margin-top: 0;
  text-transform: uppercase;
}

.subsection-header {
  font-size: var(--font-l);
  font-weight: 400;
  margin-bottom: var(--spacing-s);
  margin-top: var(--spacing-m);
}

.arrows {
  all: revert;
  list-style: none;
}

.arrows li::before {
  content: "\21E8";
  float: left;
  font-family: inria-sans;
  margin-left: -2.0rem;
  position: absolute;
}

.columns {
  column-count: 2;
  list-style-type: none;
  padding: 0px;
}

@media (max-width: 600px) {
  .columns {
    column-count: 1;
    list-style-position: outside;
    list-style-type: disc;
  }
}

#d-hexagonal-binning-plots, #references {
  border: 0;
  border-bottom: 1px dashed;
  margin-bottom: var(--spacing-xl);
  padding-bottom: var(--spacing-xl);
}

#index-of-used-functions-and-methods {
  padding-bottom: var(--spacing-xl);
}

/* Layout */

.blog-index__item:last-child {
  margin-block-end: var(--spacing-m);
}

.cluster {
  align-items: center;
  display: flex;
  flex-wrap: wrap;
  gap: var(--spacing-m);
}

.frame {
  --n: 4.5; /* numerator */
  --d: 6; /* denominator */
  aspect-ratio: var(--n) / var(--d);
  overflow: hidden;
  display: flex;
  justify-content: center;
  align-items: center;
}

.frame > img {
  inline-size: 100%;
  block-size: 100%;
  object-fit: cover;
}

.figure {
  font-family: var(--font-ui);
  font-size: var(--font-s);
  line-height: var(--font-line-height-s);
  text-align: center;
}

.figure > img {
  border: solid 12px white;
  border-radius: .3rem;
  box-shadow: 0px 6px 24px rgb(104, 0, 179, 0.15);
  display: block;
  margin: auto;
  width: 75%;
}

[class^='stack'] > * {
  /* top and bottom margins in horizontal-tb writing mode */
  margin-block: 0;
}

.stack-large > * + * {
  margin-block-start: 3.25rem;
}

.stack-small > * + * {
  margin-block-start: 1.5rem;
}

.section > * {
  margin-block: 0;
}

.section > * + * {
  margin-block-start: 1rem;
}

.stack-medium > * + * {
  margin-block-start: 2.2rem;
}

ul li, ol li {
  padding: var(--spacing-s) 0px;
}

/* Components */

.am-back-link {
  color: CanvasText;
  display: inline-block;
  font-family: var(--font-ui);
  font-size: var(--font-s);
  margin-top: 15px;
  margin-bottom: 15px;
  padding-left: .875em;
  position: relative;
}

.am-back-link::before {
  content: "";
  display: block;
  position: absolute;
  top: 3px;
  bottom: 0;
  left: .1875em;
  width: .4375em;
  height: .4375em;
  margin: auto 0;
  transform: rotate(225deg);
  border: solid;
  border-width: max(1px, .0625em) max(1px, .0625em) 0 0;
  border-color: CanvasText;
}

.am-back-link::after {
  content: "";
  position: absolute;
  top: -14px;
  right: 0;
  bottom: -14px;
  left: 0;
}

.am-breadcrumbs {
  color: CanvasText;
  font-family: var(--font-ui);
  font-size: var(--font-s);
  margin-top: 15px;
  margin-bottom: 15px;
}

.am-breadcrumbs__list {
  margin: 0;
  padding: 0;
  list-style-type: none;
}

.am-breadcrumbs__list::after {
  content: "";
  display: block;
  clear: both;
}

.am-breadcrumbs__list-item {
  display: inline-block;
  position: relative;
  margin-bottom: 5px;
  margin-left: .625em;
  padding-left: .978em;
  float: left;
}

.am-breadcrumbs__list-item:first-child {
  margin-left: 0;
  padding-left: 0;
}

.am-breadcrumbs__list-item::before {
  content: "";
  display: block;
  position: absolute;
  top: 0;
  bottom: 0;
  left: -.2em;
  width: .4375em;
  height: .4375em;
  margin: auto 0;
  transform: rotate(45deg);
  border: solid;
  border-width: max(1px, .0625em) max(1px, .0625em) 0 0;
  border-color: var(--color-secondary-text);
}

.am-breadcrumbs__list-item:first-child::before {
  content: none;
  display: none;
}

.am-breadcrumbs__link {
  color: inherit;
  font-family: var(--font-ui);
  text-decoration-thickness: 1px;
}

.am-breadcrumbs__link:active, .am-breadcrumbs__link-item:link, .am-breadcrumbs__link:visited {
  color: CanvasText;
}

.am-button {

  /* Configuration */
  --button-padding: 0.06em 1.4em;
  --button-gap: 0.5em;
  --button-bg: var(--color-surface-bg);
  --button-color: ButtonText;
  --button-hover-bg: var(--lesslight);
  --button-hover-color: ButtonText;
  --button-border-width: 2px;
  --button-border-style: solid;
  --button-border-color: var(--color-secondary-text);
  --button-font-size: var(--font-default);
  --button-font-weight: 500;
  --button-radius: 1.27em;
  --button-outline-width: 3px;
  --button-outline-color: Highlight;
  --button-outline-offset: 3px;

  /* Layout and spacing */
  display: inline-flex;
  align-items: center;
  gap: var(--button-gap);
  padding: var(--button-padding) calc(0.15em + 1px);

  /* Colours */
  background: var(--button-bg);
  color: var(--button-color);

  /* Stroke and radius */
  border-width: var(--button-border-width);
  border-style: var(--button-border-style);
  border-color: var(--button-border-color);
  border-radius: var(--button-radius);
  box-shadow: 0px 4px 6px 0px var(--lesslight);

  /* border-bottom: 4px solid var(--button-hover-bg); */

  /* Typography */
  text-decoration: none;
  font-weight: var(--button-font-weight, 700);
  font-size: var(--button-font-size, 1em);
  letter-spacing: 0.03ch;
  font-family: var(--font-ui);
  line-height: var(--font-line-height-s);

  /* Interactive */
  cursor: pointer;

}

/* Firefox target */
@supports (-moz-appearance: none) {
  .am-button {
    padding: var(--button-padding) calc(0.12em + 2px);
  }
}

.am-button:active {
  transform: scale(99%);
}

.am-button:hover {
  background: var(--button-hover-bg);
  color: var(--button-hover-color);
  text-decoration: none;
}

.am-button:focus {
  outline-width: var(
	  --button-outline-width,
	  var(--button-border-width)
  );
  outline-style: var(
	  --button-outline-style,
	  var(--button-border-style)
  );
  outline-color: var(
	  --button-outline-color,
	  var(--button-border-color)
  );
  outline-offset: var(
	  --button-outline-offset,
	  calc(var(--button-border-width) * 2)
  );
}

.am-button[data-button-variant="default"] {
    --button-bg: var(--color-focus);
    --button-color: var(--light);
    --button-border-color: var(--color-focus-shade);
    --button-hover-bg: var(--color-focus-shade);
    --button-hover-color: var(--light);
}

.am-button[data-button-radius="lessrounded"] {
  --button-padding: 0.12em 1.4em;
  --button-radius: 0.3em;
  letter-spacing: unset;
}

.am-header {
  color: var(--light);
  line-height: var(--font-line-height-s);
  padding-top: 16px;
  padding-bottom: 14px;
}

.am-width-container {
  margin-left: auto;
  margin-right: auto;
  max-inline-size: var(--max-width);
  padding-left: var(--spacing-l);
  padding-right: var(--spacing-l);
}

.am-navigation {
    background-color: var(--color-surface-bg);
    border-bottom: 1px solid var(--color-surface-border);
    color: var(--color-text);
    font-family: var(--font-ui);
}

.am-navigation__container {
    align-items: start;
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
}

.am-navigation__wrapper {
    flex-grow: 1;
}

.am-navigation__list {
    display: flex;
    flex-wrap: wrap;
    list-style: none;
    margin-bottom: 0;
    margin-top: 0;
    padding: 0;
}

.am-navigation__item:not(:last-child) {
    margin-right: 24px;
}

.am-navigation__item {
    border-color: LinkText;
    border-style: solid;
    border-width: 0;
    display: inline-block;
    line-height: var(--font-line-height-l);
    margin-left: 0;
    margin-top: 0;
    padding: 15px 0;
    position: relative;
}

.am-navigation__item--active {
    border-bottom-width: 5px;
    padding-bottom: 10px;
}

.am-navigation__link {
    text-decoration: none;
}

.am-footer {
    background-color: var(--color-surface-bg);
    border-top: 5px ridge;
    border-top-color: var(--color-surface-border);
    padding-top: var(--spacing-l);
    padding-bottom: var(--spacing-xl);
}
